#include "EZ.h"

static quit(EZ_Widget *widget, void *data)
{
  if(getenv("SIMAGE"))
    {
      FILE *fp = fopen("flistbox.ppm", "w");
      if(fp) 
	{
	  EZ_SaveWidget2PPM(data, fp);
	  fclose(fp);
	}
    }
  EZ_Shutdown();
  exit(0);
}

main(int ac, char **av)
{
  EZ_Widget *frame, *flistbox, *frame5, *btn, *tmp;
  char       str[256];
  FILE       *fp;
  EZ_Item    *items[10];
  int i, cnt=1;

  EZ_Initialize(ac,av,0);
  frame  = EZ_CreateWidgetXrm(EZ_WIDGET_FRAME,    NULL,
                              "Frames",           "frames",
                              EZ_FILL_MODE,       EZ_FILL_BOTH,
                              EZ_IPADX,           4,
                              0);

  flistbox = EZ_CreateWidget(EZ_WIDGET_FANCY_LIST_BOX, frame,
			     EZ_FANCY_LIST_BOX_COLUMNS, 6,
			     EZ_IPADY, 0,
			     EZ_IPADX, 0,
			     EZ_PADY,  1,
			     EZ_BORDER_WIDTH, 2,
			     EZ_FANCY_LIST_BOX_TYPE, 1, 
			     EZ_SELECTION_FOREGROUND, "blue",
			     EZ_SELECTION_BACKGROUND, "yellow",
			     150, 0,  NULL, NULL,
			     0);			     
  fp = popen("ls -alg | awk '{print $9 \" \" $3 \" \" $4 \" \" $5 \" \" $1}'", "r");
  if(fp)
    {
      char fields[6][32];
      while(fgets(str, 255, fp) != NULL)
        {
          if(sscanf(str, "%s %s %s %s %s",fields[0],fields[1],fields[2],fields[3],fields[4]) == 5)
            {
	      for(i = 0; i < 5; i++)
                {
		  items[i] = EZ_CreateItem(EZ_LABEL_ITEM,
					   EZ_LABEL_STRING, fields[i],
					   EZ_BORDER_WIDTH, 1,
					   EZ_BORDER_TYPE, EZ_BORDER_TB_UP,
					   0);
		  
                  switch(i)
                    {
                    case 0:  EZ_ConfigureItem(items[i], EZ_FOREGROUND, "red",EZ_PADX, 4,0); 
                      if(fields[4][0] == 'd') EZ_ConfigureItem(items[i], EZ_PIXMAP_FILE, "folder.xpm", 0);
                      else  EZ_ConfigureItem(items[i], EZ_PIXMAP_FILE, "file.xpm",0);
                      break;
                    case 1:  EZ_ConfigureItem(items[i], EZ_FOREGROUND, "blue",0); break;
                    case 2:  EZ_ConfigureItem(items[i], EZ_FOREGROUND, "yellow",0); break;
                    case 3:  EZ_ConfigureItem(items[i], EZ_FOREGROUND, "cyan",0); break;
                    case 4:  EZ_ConfigureItem(items[i], EZ_FOREGROUND, "magenta",0); break;
                    default: break;
                    }
                }
	      {
		char tstr[16]; sprintf(tstr, " %d", cnt++);
		items[5] = EZ_CreateItem(EZ_LABEL_ITEM, 
					 EZ_LABEL_STRING, tstr, 
					 EZ_BORDER_TYPE, EZ_BORDER_TB_UP,
					 EZ_BORDER_WIDTH, 1,
					 0); 
	      }
              EZ_FancyListBoxInsertRow(flistbox, items, 6, 
				       EZ_GetFancyListBoxNumberOfRows(flistbox)
				       ); /* at the end */
            }
        }
      /* a header */
      items[0] = EZ_CreateLabelItem("File/Dir Name", NULL);
      items[1] = EZ_CreateLabelItem("User Name", NULL);
      items[2] = EZ_CreateLabelItem("Group Name", NULL);
      items[3] = EZ_CreateLabelItem("File Size ", NULL);
      items[4] = EZ_CreateLabelItem("Permissions", NULL);
      items[5] = EZ_CreateLabelItem("Count", NULL);
      for(i = 0; i < 5; i++)
        {
          switch(i)
            {
            case 0:  EZ_ConfigureItem(items[i], EZ_FOREGROUND, "red",0); break;
            case 1:  EZ_ConfigureItem(items[i], EZ_FOREGROUND, "blue",0); break;
            case 2:  EZ_ConfigureItem(items[i], EZ_FOREGROUND, "yellow",0); break;
            case 3:  EZ_ConfigureItem(items[i], EZ_FOREGROUND, "cyan",0); break;
            case 4:  EZ_ConfigureItem(items[i], EZ_FOREGROUND, "magenta",0); break;
            default: break;
            }
          EZ_ConfigureItem(items[i], EZ_BORDER_WIDTH,1,EZ_BORDER_TYPE, EZ_BORDER_TB_UP,
                           EZ_BACKGROUND, "bisque2", EZ_PADY, 2,
			   EZ_BORDER_WIDTH, 1,
                           EZ_LABEL_POSITION, EZ_LEFT, 0);
        }
      EZ_SetFancyListBoxHeader(flistbox, items, 6);
    }
  pclose(fp);

  frame5 = EZ_CreateWidgetXrm(EZ_WIDGET_FRAME,    frame,
                              "Frame5",           "frame5",
                              EZ_BG_IMAGE_FILE,   "marble",
                              EZ_DOCKABLE,        True,
                              EZ_BORDER_TYPE,     EZ_BORDER_RAISED,
                              EZ_BORDER_WIDTH,    2,
                              0);
  btn  =   EZ_CreateWidgetXrm(EZ_WIDGET_NORMAL_BUTTON,    frame5,
                              "AButton",           "aButton",
                              EZ_LABEL_STRING,     "Done",
                              EZ_CALLBACK,          quit, frame,
                              0);
  EZ_DisplayWidget(frame);
  EZ_EventMainLoop();
}
