/* Use resource to select callbacks 
run with
   hibye -xrm "*btn.callback: bye"
or 
   hibye -xrm "*btn.callback: hi"
 */

#include "EZ.h"

static void sayHi(EZ_Widget *widget, void *data)
{  printf("Hello, there\n"); }

static void sayBye(EZ_Widget *widget, void *data)
{  printf("Goodbye!\n"); }


main(int ac, char **av)
{
  EZ_Widget *btn;

  EZ_Initialize(ac, av, 0);
  fprintf(stderr, "\nRun with: av[0] -xrm \"*btn.callback: hi\" \nor\n         av[0] -xrm \"*btn.callback: bye\"\n");
  
  btn  =   EZ_CreateWidgetXrm(EZ_WIDGET_NORMAL_BUTTON,    NULL,
                              "Btn",           "btn",
                              EZ_LABEL_STRING,     "The callbacks of this button\nis set by Resource",
                              0);
  /* select callback from resources */
  {
    char *value;
    if(EZ_GetWidgetResource(btn, "callback", &value))
      {
        if(!strncmp(value, "hi",2)) EZ_AddWidgetCallBack(btn, EZ_CALLBACK, sayHi, NULL, 0);
        else if(!strncmp(value, "bye",3)) EZ_AddWidgetCallBack(btn, EZ_CALLBACK, sayBye, NULL, 0);
      }
  }

  EZ_DisplayWidget(btn);
  EZ_EventMainLoop();
}


