#include "EZ.h"

static quit(EZ_Widget *widget, void *data)
{
  if(getenv("SIMAGE"))
    {
      FILE *fp = fopen("slider.ppm", "w");
      if(fp) 
	{
	  EZ_SaveWidget2PPM(data, fp);
	  fclose(fp);
	}
    }
  EZ_Shutdown();
  exit(0);
}
main(int ac, char **av)
{
  EZ_Widget *frame, *slider1, *slider2, *slider12, *slider21, *slider3, *slider4, *frame5, *btn;

  EZ_Initialize(ac, av, 0);
  frame  = EZ_CreateWidgetXrm(EZ_WIDGET_FRAME,    NULL,
                              "Frames",           "frames",
                              EZ_FILL_MODE,       EZ_FILL_BOTH,
                              EZ_IPADX,           4,
                              EZ_GRID_CONSTRAINS, EZ_ROW,    0, 100,  100,   0, 
                              EZ_GRID_CONSTRAINS, EZ_COLUMN, 0, 200,  100,   0, 
                              0);
  slider1= EZ_CreateWidgetXrm(EZ_WIDGET_HORIZONTAL_SLIDER,  frame,
                              "Slider1",           "slider1",
                              EZ_LABEL_STRING,     "H slider, Type=0",
                              EZ_BACKGROUND,        "#cc00cc",
                              EZ_GRID_CELL_GEOMETRY,   0, 0, 1, 1,
                              EZ_GRID_CELL_PLACEMENT,  EZ_FILL_BOTH, EZ_CENTER,
                              0);
  slider2= EZ_CreateWidgetXrm(EZ_WIDGET_HORIZONTAL_SLIDER,  frame,
                              "Slider2",           "slider2",
                              EZ_LABEL_STRING,     "H slider, Type=1",
                              EZ_SLIDER_STYLE,      1,
                              EZ_SLIDER_RANGE,     -10.0, 10.0,
                              EZ_SLIDER_RESOLUTION, 1.0,
                              EZ_GRID_CELL_GEOMETRY,   0, 1, 1, 1,
                              EZ_GRID_CELL_PLACEMENT,  EZ_FILL_BOTH, EZ_CENTER,
                              0);

  slider12=EZ_CreateWidgetXrm(EZ_WIDGET_HORIZONTAL_SLIDER,  frame,
                              "Slider12",           "slider12",
                              EZ_LABEL_STRING,     "H slider, Type=2",
                              EZ_SLIDER_STYLE,      2,
                              EZ_GRID_CELL_GEOMETRY,  0, 2, 1, 1,
                              EZ_GRID_CELL_PLACEMENT,  EZ_FILL_BOTH, EZ_CENTER,
                              0);

  slider21=EZ_CreateWidgetXrm(EZ_WIDGET_HORIZONTAL_SLIDER,  frame,
                              "Slider21",           "slider21",
                              EZ_LABEL_STRING,     "H slider, Type=3",
                              EZ_SLIDER_STYLE,      3,
                              EZ_SLIDER_DISPLAY_VALUE,  False,
                              EZ_GRID_CELL_GEOMETRY,  0, 3, 1, 1,
                              EZ_GRID_CELL_PLACEMENT,  EZ_FILL_BOTH, EZ_CENTER,
                              0);
  slider3= EZ_CreateWidgetXrm(EZ_WIDGET_VERTICAL_SLIDER,  frame,
                              "Slider3",           "slider3",
                              EZ_GRID_CELL_GEOMETRY,   1, 0, 1, 4,
                              EZ_GRID_CELL_PLACEMENT,  EZ_FILL_BOTH, EZ_CENTER,
                              EZ_WIDTH, 0,
                              0);
  slider4= EZ_CreateWidgetXrm(EZ_WIDGET_VERTICAL_SLIDER,  frame,
                              "Slider4",              "slider4",
                              EZ_BACKGROUND,        "#00cccc",
                              EZ_SLIDER_STYLE,          3,
                              EZ_SLIDER_DISPLAY_VALUE,  False,
                              EZ_GRID_CELL_GEOMETRY,   2, 0, 1, 4,
                              EZ_GRID_CELL_PLACEMENT,  EZ_FILL_BOTH, EZ_CENTER,
                              0);

  frame5 = EZ_CreateWidgetXrm(EZ_WIDGET_FRAME,    frame,
                              "Frame5",           "frame5",
                              EZ_BG_IMAGE_FILE,   "marble",
                              EZ_DOCKABLE,        True,
                              EZ_BORDER_TYPE,     EZ_BORDER_RAISED,
                              EZ_BORDER_WIDTH,    2,
                              0);
  btn  =   EZ_CreateWidgetXrm(EZ_WIDGET_NORMAL_BUTTON,    frame5,
                              "AButton",           "aButton",
                              EZ_LABEL_STRING,     "Done",
                              EZ_CALLBACK,          quit, frame,
                              0);
  EZ_DisplayWidget(frame);
  EZ_EventMainLoop();
}
